<?php
/**
 * @version    1.0
 * @package    besa
 * @author     Thembay Team <support@thembay.com>
 * @copyright  Copyright (C) 2019 Thembay.com. All Rights Reserved.
 * @license    GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Websites: https://thembay.com
 */

add_action('wp_enqueue_scripts', 'besa_child_enqueue_styles', 10000);
function besa_child_enqueue_styles() {
	$parent_style = 'besa-style';
	wp_enqueue_style( $parent_style, get_template_directory_uri() . '/style.css' );

    wp_enqueue_style( 'linearicons', get_stylesheet_directory_uri() . '/css/linearicons.css', array(), '1.0.0' );

    wp_enqueue_style( 'besa-child-style',
        get_stylesheet_directory_uri() . '/style.css',
        array( $parent_style ),
        wp_get_theme()->get('Version')
    );
}

add_action( 'elementor/icons_manager/additional_tabs', 'besa_child_elementor_icon_control_linear_icons', 10, 1 );
function besa_child_elementor_icon_control_linear_icons( $tabs ) {

    if( besa_tbay_get_config( 'show_font_linearicons', true ) ) {
        $tabs['linear-icons'] = [
            'name'          => 'linear-icons',
            'label'         => esc_html__( 'Linear icons', 'besa' ),
            'prefix'        => 'linear-icon-', 
            'displayPrefix' => 'linear-icon-',
            'labelIcon'     => 'fa fa-font-awesome',
            'ver'           => '1.0.0',
            'fetchJson'     => get_stylesheet_directory_uri() . '/icons/json/linearicons.json', 
            'native'        => true,
        ];		
    }

    return $tabs;	
}

function besa_child_enqueue_editor_icons()
{
    wp_enqueue_style( 'linearicons', get_stylesheet_directory_uri() . '/css/linearicons.css', array(), '1.0.0' );
}
add_action('elementor/editor/after_enqueue_styles', 'besa_child_enqueue_editor_icons', 99);

